<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfArmazemLocalizacaoERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfArmazemLocalizacaoERP
 * @subpackage Arrays
 */
class ArrayOfArmazemLocalizacaoERP extends AbstractStructArrayBase
{
    /**
     * The ArmazemLocalizacaoERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ArmazemLocalizacaoERP[]
     */
    public $ArmazemLocalizacaoERP;
    /**
     * Constructor method for ArrayOfArmazemLocalizacaoERP
     * @uses ArrayOfArmazemLocalizacaoERP::setArmazemLocalizacaoERP()
     * @param \StructType\ArmazemLocalizacaoERP[] $armazemLocalizacaoERP
     */
    public function __construct(array $armazemLocalizacaoERP = array())
    {
        $this
            ->setArmazemLocalizacaoERP($armazemLocalizacaoERP);
    }
    /**
     * Get ArmazemLocalizacaoERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ArmazemLocalizacaoERP[]|null
     */
    public function getArmazemLocalizacaoERP()
    {
        return isset($this->ArmazemLocalizacaoERP) ? $this->ArmazemLocalizacaoERP : null;
    }
    /**
     * Set ArmazemLocalizacaoERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ArmazemLocalizacaoERP[] $armazemLocalizacaoERP
     * @return \ArrayType\ArrayOfArmazemLocalizacaoERP
     */
    public function setArmazemLocalizacaoERP(array $armazemLocalizacaoERP = array())
    {
        foreach ($armazemLocalizacaoERP as $arrayOfArmazemLocalizacaoERPArmazemLocalizacaoERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfArmazemLocalizacaoERPArmazemLocalizacaoERPItem instanceof \StructType\ArmazemLocalizacaoERP) {
                throw new \InvalidArgumentException(sprintf('The ArmazemLocalizacaoERP property can only contain items of \StructType\ArmazemLocalizacaoERP, "%s" given', is_object($arrayOfArmazemLocalizacaoERPArmazemLocalizacaoERPItem) ? get_class($arrayOfArmazemLocalizacaoERPArmazemLocalizacaoERPItem) : gettype($arrayOfArmazemLocalizacaoERPArmazemLocalizacaoERPItem)), __LINE__);
            }
        }
        if (is_null($armazemLocalizacaoERP) || (is_array($armazemLocalizacaoERP) && empty($armazemLocalizacaoERP))) {
            unset($this->ArmazemLocalizacaoERP);
        } else {
            $this->ArmazemLocalizacaoERP = $armazemLocalizacaoERP;
        }
        return $this;
    }
    /**
     * Add item to ArmazemLocalizacaoERP value
     * @throws \InvalidArgumentException
     * @param \StructType\ArmazemLocalizacaoERP $item
     * @return \ArrayType\ArrayOfArmazemLocalizacaoERP
     */
    public function addToArmazemLocalizacaoERP(\StructType\ArmazemLocalizacaoERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ArmazemLocalizacaoERP) {
            throw new \InvalidArgumentException(sprintf('The ArmazemLocalizacaoERP property can only contain items of \StructType\ArmazemLocalizacaoERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ArmazemLocalizacaoERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ArmazemLocalizacaoERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ArmazemLocalizacaoERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ArmazemLocalizacaoERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ArmazemLocalizacaoERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ArmazemLocalizacaoERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArmazemLocalizacaoERP
     */
    public function getAttributeName()
    {
        return 'ArmazemLocalizacaoERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfArmazemLocalizacaoERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
